import junit.framework.TestCase;
import org.junit.After;
import org.junit.Assert;
import org.junit.Before;
import org.junit.Test;
import org.junit.runners.Parameterized;

import java.util.ArrayList;

import static org.junit.Assert.*;

/*
Classe de test pour le déplacement du cavalierB.
 */
public class TestDepT {
    @Parameterized.Parameter
    protected Tour tourB;
    @Parameterized.Parameter
    protected Tour tourN;
    @Parameterized.Parameter
    protected Echiquier ech;

    @Before
    public void setUP(){
        tourB = new Tour(Piece.BLANC);
        tourN = new Tour(Piece.NOIR);
        ech = new Echiquier();
    }

    @After
    public void tearDown(){
    }

    @Test
    public void TestPlacement() throws Exception{
        ech.placer(tourB,6,6);
        Assert.assertEquals(tourB, ech.getPiece(6,6));
    }

    @Test
    public void TestDeplacement() throws Exception{
        /*
        Deplacement Vertical
         */
        ech.placer(tourB,5,5);
        ech.deplacer(5,5,6,5);
        Assert.assertEquals(tourB,ech.getPiece(6,5));
        /*
        Deplacement Horizontal
         */
        ech.placer(tourN,3,3);
        ech.deplacer(3,3,3,4);
        Assert.assertEquals(tourN, ech.getPiece(3,4));
    }

    @Test
    public void TestPrise() throws Exception{
        ech.placer(tourB,5,5);
        ech.placer(tourN,6,5);
        ech.deplacer(5,5,6,5);
        Assert.assertEquals(tourB, ech.getPiece(6,5));
    }
}